program Recorder;

uses windows,
     recunit,
     mmsystem,
     lame_dll,
     messages;

type
  PWR = ^TWR;
  TWR = class(TWaveRecorder)
  public
    procedure ProcessBuffer(uMsg : Word; P : Pointer; n : Integer; dwParam1: dword); override;
  end;

var
  wc : TWndClassEx;
  MainWnd : HWND;
  btns : array[0..2] of HWND;
  Mesg : TMsg;
  VarFont : HWnd;

  WaveRecorder: TWR;
  beConfig    : TBeConfig;
  hFile: hWnd;
  hLame : cardinal;
  NumSamples,
  Mp3BufSize : DWORD;
  Mp3Buffer: pointer;
  toWrite,
  toRead,
  dwWrite : DWORD;
  FileLen: integer = 0;

function ToString(rReal: Real; const n: integer): String;
begin
  str(rReal: 1: n, result);
end;

procedure TWR.ProcessBuffer(uMsg : Word; P : Pointer; n : Integer; dwParam1: dword);
var
  done: DWORD;
  len: DWORD;
begin
  case umsg of
    MM_WIM_OPEN:
    begin
      FillChar(BeConfig, SizeOf(BeConfig), #0);
      BeConfig.Format.dwConfig:= BE_CONFIG_LAME;
      with BeConfig.Format.LHV1 do
      begin
        dwStructSize:= sizeof(TLHV1);
        bCopyright:= true;
        dwReSampleRate:= 44100;
        dwSampleRate:= 44100;
        nMode:= BE_MP3_MODE_STEREO;
        dwBitrate:= 128;
      end;
      filelen:= 0;
      PostMessage(MainWnd, wm_user+1, 0, filelen);
      BeInitStream(BeConfig, NumSamples, Mp3BufSize, hLame);
      GetMem(Mp3Buffer, Mp3BufSize);
      hFile:= CreateFile('file.mp3', GENERIC_WRITE, FILE_SHARE_READ, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
    end;
    MM_WIM_CLOSE:
    begin
      beDeinitStream(hLame, mp3Buffer, dwWrite);
      WriteFile(hFile, mp3buffer^, toWrite, dwWrite, nil);
      filelen:= filelen + integer(dwWrite);
      PostMessage(MainWnd, wm_user+1, 0, filelen);
      beCloseStream(hLame);
      FreeMem(Mp3Buffer);
      CloseHandle(hFile);
    end;
    MM_WIM_DATA:
    begin
      done:= 0;
      len:= pWAVEHDR(dwParam1).dwBytesRecorded;
      while done < len do
      begin
        if (done + NumSamples * 2) < len
        then toRead := NumSamples * 2
        else toRead := len - done;
        beEncodeChunk(hLame, toRead div 2, @pWAVEHDR(dwParam1).lpData[done], mp3Buffer, toWrite);
        WriteFile(hFile, mp3buffer^, toWrite, dwWrite, nil);
        filelen:= filelen + integer(dwWrite);
        done := Done + ToRead;
      end;
      PostMessage(MainWnd, wm_user+1, 0, filelen);
    end;
  end;
end;

function WindowProc(wnd:HWND; Msg : Integer; Wparam:Wparam; Lparam:Lparam):Lresult; stdcall;
Begin
  case msg of
    wm_user+1: SetWindowText(wnd, PChar(ToString(lParam/1024, 1)+' Kbytes'));
    wm_command:
    begin
      if lparam = integer(Btns[0]) then
      begin
        WaveRecorder.pWaveFmtEx.wFormatTag := WAVE_FORMAT_PCM;
        WaveRecorder.pWaveFmtEx.nChannels := 2;
        WaveRecorder.pWaveFmtEx.nSamplesPerSec := 44100;
        WaveRecorder.pWaveFmtEx.wBitsPerSample := 16;
        WaveRecorder.pWaveFmtEx.nAvgBytesPerSec := WaveRecorder.pWaveFmtEx.nSamplesPerSec*(WaveRecorder.pWaveFmtEx.wBitsPerSample div 8)*WaveRecorder.pWaveFmtEx.nChannels;
        WaveRecorder.SetupRecord(@WaveRecorder);
//  
        WaveRecorder.StartRecord;
      end;
      if lparam = integer(Btns[1]) then
      begin
        WaveRecorder.StopRecord;
      end;
    end;
    wm_destroy :
    Begin
      WaveRecorder.StopRecord;
      WaveRecorder.Destroy;
      Result:=0;
      postquitmessage(0);
      exit;
    End;
  end;
  Result:= DefWindowProc(wnd,msg,wparam,lparam);
end;


var xPos,yPos,nWidth,nHeight : Integer;
   i : Byte;

begin
wc.cbSize:=sizeof(wc);
wc.style:=cs_hredraw or cs_vredraw;
wc.lpfnWndProc:=@WindowProc;
wc.cbClsExtra:=0;
wc.cbWndExtra:=0;
wc.hInstance:=HInstance;
wc.hIcon:=LoadIcon(0,idi_application);
wc.hCursor:=LoadCursor(0,idc_arrow);
wc.hbrBackground:=COLOR_BTNFACE+1;
wc.lpszMenuName:=nil;
wc.lpszClassName:='Recorder class';

RegisterClassEx(wc);

VarFont := CreateFont(8, 0, 0, 0,FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET,OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,DEFAULT_PITCH or FF_DONTCARE, 'MS Sans Serif');

xPos:=100;
yPos:=150;
nWidth:=200;
nHeight:=100;


MainWnd:=CreateWindowEx(0,'Recorder class',
'Line-in recorder',
WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX,
xPos,yPos,nWidth,nHeight,0,0,
Hinstance,nil);

Btns[0]:=CreateWindowEx(0,'button','',bs_pushbutton or ws_child,10,10,150,25,MainWnd,0,hinstance,nil);
Btns[1]:=CreateWindowEx(0,'button','',bs_defpushbutton or ws_child ,10,40,150,25,MainWnd,0,hinstance,nil);

for i:=0 to 1 do begin
  SendMessage(Btns[i],wm_setfont,VarFont,0);
  ShowWindow(Btns[i],sw_show);
end;
WaveRecorder := TWR.Create(65536, 2);
ShowWindow(MainWnd,CmdShow);

While GetMessage(Mesg,0,0,0) do
 begin
  TranslateMessage(Mesg);
  DispatchMessage(Mesg);
 end;

end.
